#!/usr/bin/haserl
<?
. /usr/lib/webif/webif.sh

dpkg -l phidget22networkserver | grep ^ii 2>&1 1>/dev/null && installed="true" || installed="false"
ps auxww | grep -v grep | grep -q "\/usr\/bin\/phidget22networkserver " && running="true" || running="false"
ls /etc/rc4.d/*phidget22networkserver 1> /dev/null 2>&1 && enabled="true" || enabled="false"
p22nsconfig=/etc/phidgets/phidget22networkserver.pc

header "Phidgets" "Control Panel" "Phidget Control Panel"

if [ "$installed" = "false" ]; then

	cat <<EOF
The control panel requires the phidget22 network server to be installed. You can install it from the <a href="/cgi-bin/system-packages.sh">Packages</a> page, or via SSH.
EOF

elif [ "$running" = "false" ]; then

	cat <<EOF
The control panel requires the phidget22 network server to be running.
You can start it from the <a href="/cgi-bin/phidgets-networkservice.sh">Phidget22 Network Server</a> page
EOF

elif [ "$enabled" != "true" ]; then

	cat <<EOF
The control panel requires the phidget22 network server and web server to be enabled.
You can enable then from the <a href="/cgi-bin/phidgets-networkservice.sh">Phidget22 Network Server</a> page.
EOF

else

	# Try to find addr that user has typed into brower, other wise fall back on eth0 addr, and finally on wlan0 addr
	_host="${HTTP_REFERER#http://}"
	_host="${_host%%/*}"
	if empty $_host; then
		for ipaddr in $(hostname -I); do
			if ! empty "$ipaddr" && ! equal "$ipaddr" "127.0.0.1"; then
				_host="$ipaddr"
				break
			fi
		done
	fi
	_p22ns_www_port=$(pconf_get $p22nsconfig phidget.www.network.ipv4.port 8080)

	cat <<EOF
<div id="controlpanel">
	<iframe src="http://$_host:$_p22ns_www_port/index.html"></iframe>
</div>
<br>
<strong>Note:</strong> This page is designed only to display Phidgets directly connected to this SBC. Other Phidgets may be available over the network, but they will not be displayed here.

EOF

fi

footer ?>
<!--
##WEBIF:name:Phidgets:200:Control Panel
-->
